﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private plt As Form
	Private fx As JFX
	Private lumcv As Canvas

	Private Hue, Sat, Lum As Float
	Private palette, pltcursor, lumcursor As ImageView
	Private Bcolor,  Rcolor,  Gcolor As Label
	Private mymodule As Object
	Private  selectedcolor As Paint
	Private basepnl, lumpane, pltpane As Pane
	Private myname As String
	Private oklbl As Label
	Private cancellbl As Label
	Private xview As B4XView
	Private xui As XUI
End Sub

'Initializes the object
'Example:
'mycol.Initialize(Activity, "main", "mycol")
Public Sub Initialize(Parent As Object, Module As Object, Eventname As String)
plt.Initialize("plt",470,290)	
plt.RootPane.LoadLayout("palette") 'Load the layout file.
selectedcolor = fx.Colors.Blue
mymodule = Module
myname = Eventname
xview = oklbl
End Sub

'Shows the palette for color selection.
'The color is returned after "OK" button press to 
'wait for [object name] _Result( col As paint, success as boolean) in the calling module.
'success is true if color is selected, false if cancel is used.
'The Palette will show the default color when displayed.
Public Sub  GetColor 
	COLORtoHSL(selectedcolor)
	drawlum
	plt.Show
	show_color
End Sub

Private Sub oklbl_MouseClicked (EventData As MouseEvent)
	CallSub3(mymodule, myname & "_Result", selectedcolor, True)
	plt.Close
End Sub

Sub cancellbl_MouseClicked (EventData As MouseEvent)
	CallSub3(mymodule, myname & "_Result", selectedcolor, False)
	plt.Close
End Sub

Private Sub drawlum
	Dim col As Paint
	Dim k As Float
	For i = 0 To lumcv.Height - 1
		k = i
		col = HSLToRGB(Hue,Sat, 240*(1-k / lumcv.Height))
		lumcv.DrawLine(0,i,lumcv.Width,i,col,1)
	Next
End Sub

Private Sub pltpane_MouseClicked (EventData As MouseEvent)
	Dim x,y As Int
	x = EventData.X
	y = EventData.Y
	If x < 0 Then x = 0
	If x > palette.Width Then x = palette.Width - pltcursor.Width/2
	If y < 0 Then y = 0
	If y > palette.Height Then y = palette.Height - pltcursor.height/2
	
	pltcursor.Left = x -  10
	pltcursor.Top  = y - 10
	
	Hue = x * 240 / palette.Width
	Sat = (palette.height - y) * 240/palette.Height
	Lum = 120
	lumcursor.Top = lumcv.Height/2 - lumcursor.Height/2
	selectedcolor = HSLToRGB(Hue,Sat,Lum)
	drawlum
	show_color
End Sub


private Sub lumcv_MouseClicked (EventData As MouseEvent)
	Dim y As Int
	y = EventData.y
	If y < 0 Then y = 0
	If y > lumcv.Height Then y = lumcv.Height
	Lum = (lumcv.Height - y)*240/lumcv.Height
	lumcursor.Top = y - lumcursor.Height/2
	selectedcolor = HSLToRGB(Hue,Sat,Lum)
	show_color
End Sub

private Sub show_color
	Dim clrint As Int = fx.Colors.To32Bit(selectedcolor)
	Rcolor.text = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff0000), 16)   ' R
	Gcolor.text = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff00), 8)      ' G
	Bcolor.text = Bit.And(clrint, 0xff)  ' B

	xview.SetColorAndBorder(fx.Colors.To32Bit(selectedcolor), 3, xui.Color_Black,10)
	Dim txtcol As Paint
	If Rcolor.Text+Gcolor.Text + Bcolor.Text > 128*3 Then 
		txtcol = fx.Colors.Black
	Else
		txtcol = fx.Colors.white
	End If
	oklbl.TextColor = txtcol
End Sub

'
'Returns the paint of  Lum,Sat and Hue parameters.
Public Sub HSLToRGB(H As Float,S As Float ,L As Float) As Paint
	Dim  k As Int
	Dim H0 ,M1 ,M0 , D As Float
	Dim col As Paint
			
	If H = 240 Then  H = 0  ' 240 identical To 0
	H0 =  H / 40
	If L < 120 Then
		M1=255*L*(1+S/240)/240
		M0=255*L*(1-S/240)/240
	Else
		M1=255*(L/240*(1-S/240)+S/240)
		M0=255*(L/240*(1+S/240)-S/240)
	End If
		
	D = M1 - M0
	k = H0
	Select k
		Case 0
			col = fx.colors.Rgb(M1 ,M0+H0*D,M0)
		Case 1
			col = fx.colors.Rgb(M0+(2-H0)*D,M1,M0)
		Case 2
			col = fx.colors.Rgb(M0,M1,M0+(H0-2)*D)
		Case 3
			col = fx.colors.Rgb(M0,M0+(4-H0)*D,M1)
		Case 4
			col = fx.colors.Rgb(M0+(H0-4)*D,M0,M1)
		Case 5
			col = fx.colors.Rgb(M1,M0,M0+(6-H0)*D)
	End Select
	Return col
End Sub

'Returns a Int array with Lum,Sat,Hue (by that order) from a color.
Public Sub COLORtoHSL(clr As Paint) As Int()
	Dim R,G ,B As Float
	Dim maxcolor,mincolor, D, P As Float
	Dim res(4) As Int
	
	Dim clrint As Int = fx.Colors.To32Bit(clr)
	res(0) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff000000), 24) ' alfa
	res(1) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff0000), 16)   ' R
	res(2) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff00), 8)      ' G
	res(3) = Bit.And(clrint, 0xff)                                   ' B

	R = res(1)/255   ' between 0 to 1
	G = res(2)/255
	B = res(3)/255
	maxcolor = Max(Max(R,G),B)
	mincolor = Min(Min(R,G),B)
	D = maxcolor - mincolor
	P = maxcolor + mincolor
	Lum = P/2
	If maxcolor = mincolor Or Lum = 0  Then
		Sat = 0
	Else
		If Lum < 0.5 Then
			Sat = D/P
		Else
			Sat = D/(2.0 - P)
		End If
	End If
	If maxcolor = mincolor Then
		Hue = 0
	Else
		Select maxcolor
			Case R
				Hue = ((G-B)/D)/6
			Case G
				Hue = (2 + (B-R)/D)/6
			Case B
				Hue = (4 + (R-G)/D)/6
		End Select
		If Hue < 0 Then Hue = Hue + 1
	End If
	lumcursor.Top = lumcv.Height*(1 - Lum)  - lumcursor.Height/2
	pltcursor.Left = Hue * palette.Width - pltcursor.Width/2
	pltcursor.Top =  palette.Height * (1 -  Sat) - pltcursor.Height/2
	Lum = Lum * 240
	Sat = Sat * 240
	Hue = Hue * 240
	res(0) = Lum
	res(1) = Sat
	res(2) = Hue
	Return res
End Sub

'Returns a Int array of the 4 parameters of a color :
'Alfa, R ,G, B
Public Sub ParseColor(clr As Paint) As Int()
	Dim res(4) As Int
	Dim clrint As Int = fx.Colors.To32Bit(clr)
	res(0) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff000000), 24) ' alfa
	res(1) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff0000), 16)   ' R
	res(2) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff00), 8)      ' G
	res(3) = Bit.And(clrint, 0xff)  ' B
	Return res
End Sub
