﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private plt As Form
	Private fx As JFX
	Private xview  As B4XView
	Private palette As Canvas
	Private  pltcursor As ImageView
	Private cx,cy, R1,R2 As Int
	Private Bcolor,  Rcolor,  Gcolor, oklbl, cancellbl As Label
	Private mymodule As Object
	Private selectedcolor As Paint
	Private basepnl, pltpane As Pane
	Private myname As String
	Private xui As XUI
End Sub

'Initializes the object
'Example:
'mycol.Initialize(Activity, "main", "circ")
Public Sub Initialize(Parent As Object, Module As Object, Eventname As String)
	plt.Initialize("plt",420,290)
	plt.RootPane.LoadLayout("circle") 'Load the layout file.
	selectedcolor = fx.Colors.Blue
	mymodule = Module
	myname = Eventname
	xview = oklbl
	
	cx = 120
	cy = 120
	R1 = 95
	R2 = 120
	
	Dim  img As Image
	img.Initialize(File.DirAssets,"rpc.png")
	palette.DrawImage2(img,0,0,img.Width,img.Height,25,25,190,190)
End Sub

'Shows the palette for color selection.
'The color is returned after "OK" button press to 
'wait for [object name] _Result( col As paint, success as boolean) in the calling module.
'success is true if color is selected, false if cancel is used.
'The Palette will show the default color when displayed.
Public Sub  GetColor
	drawlum
	show_color
	plt.Show
End Sub

Private Sub oklbl_MouseClicked (EventData As MouseEvent)
	CallSub3(mymodule, myname & "_Result", selectedcolor, True)
	plt.Close
End Sub

Sub cancellbl_MouseClicked (EventData As MouseEvent)
	CallSub3(mymodule, myname & "_Result", selectedcolor, False)
	plt.Close
End Sub

Private Sub drawlum
	Dim res() As Int
	res = ParseColor(selectedcolor)
	Dim col As Paint
	Dim delR1,delG1,delB1,delR2,delG2,delB2 As Double
	delR1 = (255-res(1))/360
	delG1 = (255-res(2))/360
	delB1 = (255-res(3))/360
	delR2 = res(1)/360
	delG2 = res(2)/360
	delB2 = res(3)/360
	For i = 0 To 360
		col = fx.Colors.RGB(255-i * delR1,255- i*delG1,255- i*delB1)
		palette.DrawLine(cx+R1*SinD(i/2),cy-R1*CosD(i/2),cx+R2*SinD(i/2),cy-R2*CosD(i/2),col,4)
		col = fx.Colors.RGB(i * delR2, i*delG2,i*delB2)
		palette.DrawLine(cx+R1*SinD(-i/2),cy-R1*CosD(-i/2),cx+R2*SinD(-i/2),cy-R2*CosD(-i/2),col,4)
	Next
End Sub

Private Sub pltpane_MouseClicked (EventData As MouseEvent)
	Dim x,y , rad As Int
	x = EventData.X
	y = EventData.Y
	rad = Sqrt((x-cx)*(x-cx) + (y-cy)*(y-cy))
	If rad > R2 Then Return
	Dim clr As Int = palette.Snapshot.GetPixel(X,Y)
	selectedcolor = fx.Colors.From32Bit(clr)
	pltcursor.Left = x -  pltcursor.Width/2
	pltcursor.Top  = y - pltcursor.Height/2
	If rad < R1 Then drawlum
	show_color
End Sub

private Sub show_color
	Dim clrint As Int = fx.Colors.To32Bit(selectedcolor)
	Rcolor.text = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff0000), 16)   ' R
	Gcolor.text = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff00), 8)      ' G
	Bcolor.text = Bit.And(clrint, 0xff)  ' B

	xview.SetColorAndBorder(fx.Colors.To32Bit(selectedcolor), 3, xui.Color_Black,10)
	Dim txtcol As Paint
	If Rcolor.Text+Gcolor.Text + Bcolor.Text > 128*3 Then
		txtcol = fx.Colors.Black
	Else
		txtcol = fx.Colors.white
	End If
	oklbl.TextColor = txtcol
End Sub

'Returns a Int array of the 4 parameters of a color :
'Alfa, R ,G, B
Public Sub ParseColor(clr As Paint) As Int()
	Dim res(4) As Int
	Dim clrint As Int = fx.Colors.To32Bit(clr)
	res(0) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff000000), 24) ' alfa
	res(1) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff0000), 16)   ' R
	res(2) = Bit.UnsignedShiftRight(Bit.And(clrint, 0xff00), 8)      ' G
	res(3) = Bit.And(clrint, 0xff)  ' B
	Return res
End Sub

